package com.gmh.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gmh.entity.GmhUser;
import com.gmh.entity.R;
import com.gmh.entity.SysBaijiaxing;
import com.gmh.entity.vo.ReadNameVo;
import com.gmh.service.SysBaijiaxingService;
import com.gmh.utils.POIExcelUtil;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.*;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/excel")
public class ExcelController {

    public final ThreadLocal<Workbook> workbookThreadLocal = new ThreadLocal<>();

    private static final String KEY_XINGMING = "姓名";

    @RequestMapping("/t01")
    public R test01() {
        return R.ok("ok");
    }

    @RequestMapping("/readData")
    public R readSourceData(MultipartFile file) throws IOException {
        Workbook workbook = POIExcelUtil.readExcelFromInputStream(file.getInputStream(), file.getOriginalFilename());
        List<ReadNameVo> resultList = new ArrayList<>();
        for (int i = 0; i < workbook.getNumberOfSheets(); i++) {
            ReadNameVo readNameVo = new ReadNameVo();
            Sheet sheet = workbook.getSheetAt(i);
            List<Map<String, String>> excelMaps = POIExcelUtil.toListMap(sheet);
            if (excelMaps.isEmpty()) {
                continue;
            }
            Map<String, String> firstElement = excelMaps.get(0);
            String xmKey = KEY_XINGMING;
            for (String key : firstElement.keySet()) {
                if (KEY_XINGMING.equals(firstElement.get(key))) {
                    xmKey = key;
                }
            }
            if (firstElement.containsKey(xmKey)) {
                if (!KEY_XINGMING.equals(xmKey)) {
                    excelMaps.remove(firstElement);
                }
                readNameVo = getReadNameDataForNameKey(excelMaps, xmKey);
            } else {
                Map<String, Integer> map = new HashMap<>();
                for (Map<String, String> excelMap : excelMaps) {
                    for (String key : excelMap.keySet()) {
                        String value = excelMap.get(key);
                        if (isChinaName(value)) {
                            Integer count = map.getOrDefault(key, 0);
                            map.put(key, ++count);
                        }
                    }
                }
                List<Map.Entry<String,Integer>> list = new ArrayList<>(map.entrySet());
//                list.sort(Comparator.comparingInt(Map.Entry::getValue));        //升序
                list.sort((o1, o2) -> (o2.getValue() - o1.getValue()));
                String key = list.get(0).getKey();
                readNameVo = getReadNameDataForNameKey(excelMaps, key);
            }
            readNameVo.setSheetName(sheet.getSheetName());
            resultList.add(readNameVo);
        }
        return R.ok().setData(resultList);
    }

    public ReadNameVo getReadNameDataForNameKey(List<Map<String, String>> excelMaps, final String key) {
        ReadNameVo readNameVo = new ReadNameVo();
        // 去重前
        List<GmhUser> oldNameList = excelMaps.stream().map(map -> new GmhUser(map.get(key))).collect(Collectors.toList());
        // 去重后
        LinkedHashSet<GmhUser> newNameList = new LinkedHashSet<>(oldNameList);
        readNameVo.setNameList(newNameList);
        // 重复检测
        int repeatCount = oldNameList.size() - newNameList.size();
        if (repeatCount > 0) {
            readNameVo.setHasRepeat(true);
            readNameVo.setRepeatCount(repeatCount);
        } else {
            readNameVo.setHasRepeat(false);
            readNameVo.setRepeatCount(0);
        }
        return readNameVo;
    }

    @RequestMapping("/template")
    public R templateUpload(MultipartFile file) throws IOException {
        Workbook workbook = POIExcelUtil.readExcelFromInputStream(file.getInputStream(), file.getOriginalFilename());
        List<Map<String, String>> maps = POIExcelUtil.toListMap(workbook.getSheetAt(0));
        workbookThreadLocal.set(workbook);
        return R.ok().setData(maps);
    }

    @Autowired
    private SysBaijiaxingService baijiaxingService;

    private boolean isChinaName(String val) {
        QueryWrapper<SysBaijiaxing> queryWrapper = new QueryWrapper<>();
        queryWrapper.apply("{0} LIKE CONCAT(xingshi,'%')", val);
        List<SysBaijiaxing> list = baijiaxingService.list(queryWrapper);
        return !list.isEmpty();
    }

    public void oleCode() {
//        Integer nameCellIndex = null;
//        // Sheet:nameList
//        List<ReadNameVo> readNameList = new ArrayList<>();
//        for (int i = 0; i < workbook.getNumberOfSheets(); i++) {
//            List<GmhUser> nameList = new ArrayList<>();
//            Sheet sheet = workbook.getSheetAt(i);
//            for (int r = 0; r <= sheet.getLastRowNum(); r++) {
//                Row row = sheet.getRow(r);
//                if (row == null) {
//                    continue;
//                }
//                List<List<String>> cellList = new ArrayList<>(row.getLastCellNum());
//                for (int c = 0; c < row.getLastCellNum(); c++) {
//                    Cell cell = row.getCell(c);
//                    if (cell == null) {
//                        continue;
//                    }
//                    String colString = CellReference.convertNumToColString(cell.getColumnIndex());
//                    System.out.println(colString);
//
//
//                    String stringCellValue = POIExcelUtil.getStringCellValExcludeBlank(cell);
//                    if (r == 0) {
//                        // 第一行有姓名列
//                        if ("姓名".equals(stringCellValue)) {
//                            nameCellIndex = c;
//                            break;
//                        } else {
//                            // 第一行没有指明姓名列
//                        }
//                    }
//                }
//                if (nameCellIndex != null) {
//                    Cell cell = row.getCell(nameCellIndex);
//                    String stringCellValue = POIExcelUtil.getStringCellValExcludeBlank(cell);
//                    if (!"姓名".equals(stringCellValue) && StrUtil.isNotBlank(stringCellValue)) {
//                        GmhUser user = new GmhUser();
//                        user.setName(stringCellValue);
//                        nameList.add(user);
//                    }
//                } else {
//                    System.out.println("未找到姓名列");
//                }
//            }
//            if (!nameList.isEmpty()) {
//                ReadNameVo readNameVo = new ReadNameVo();
//                readNameVo.setSheetName(sheet.getSheetName());
//                readNameVo.setNameList(nameList);
//                readNameList.add(readNameVo);
//            }
//        }
//        return R.ok().setData(readNameList);
    }

}
